# (abstract) transportation model in pyomo

from coopr.pyomo import *
model = AbstractModel()
model.Pmax = Param(within = PositiveIntegers)
model.Qmax = Param(within = PositiveIntegers)
model.P = RangeSet(1, model.Pmax)
model.Q = RangeSet(1, model.Qmax)
model.a = Param(model.P)
model.b = Param(model.Q)
model.c = Param(model.P, model.Q)
model.x = Var(model.P, model.Q, within = NonNegativeReals)
def objective_function(model):
    return sum(model.c[i,j] * model.x[i,j] for i in model.P for j in model.Q)
model.obj = Objective(rule = objective_function)
def production_constraint(model, i):
    return sum(model.x[i,j] for j in model.Q) <= model.a[i]
model.production = Constraint(model.P, rule = production_constraint)
def demand_constraint(model, j):
    return sum(model.x[i,j] for i in model.P) >= model.b[j]
model.demand = Constraint(model.Q, rule = demand_constraint)

